#ifndef VECTOR_TEST_H_
#define VECTOR_TEST_H_

#include <cppunit/extensions/HelperMacros.h>
#include <alib/compare>

class VectorTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( VectorTest );
  CPPUNIT_TEST( testProperties );
  CPPUNIT_TEST( testVectorBool );
  CPPUNIT_TEST( testVectorBool2 );
  CPPUNIT_TEST( testVectorBool3 );
  CPPUNIT_TEST( testVectorBool4 );
  CPPUNIT_TEST( testVectorBool5 );
  CPPUNIT_TEST( testVectorBool6 );
  CPPUNIT_TEST( testRange );
  CPPUNIT_TEST_SUITE_END();

public:
class Moveable {
	int& m_moves;
	int& m_copies;

public:
	Moveable(int& moves, int& copies) : m_moves(moves), m_copies(copies) {
		m_moves = 0;
		m_copies = 0;
	}

	Moveable(const Moveable& src) : m_moves(src.m_moves), m_copies(src.m_copies) {
		m_copies++;
	}

	Moveable(Moveable&& src) : m_moves(src.m_moves), m_copies(src.m_copies) {
		m_moves++;
	}

	Moveable & operator = ( const Moveable & ) {
		m_copies ++;
		return * this;
	}

	Moveable & operator = ( Moveable && ) {
		m_moves ++;
		return * this;
	}

	bool operator<(const Moveable&) const {
		return false;
	}
};

public:
  void setUp();
  void tearDown();

  void testProperties();
  void testVectorBool();
  void testVectorBool2();
  void testVectorBool3();
  void testVectorBool4();
  void testVectorBool5();
  void testVectorBool6();
  void testRange ( );
};

#endif  // VECTOR_TEST_H_
